#ifndef INERTIA_TYPEINFO_H
#define INERTIA_TYPEINFO_H

#include <rtt/types/TemplateTypeInfo.hpp>
#include <rtt/Property.hpp>
#include <rtt/PropertyBag.hpp>

#include "Inertia.h"

// << >> operators must be in the RTT namespace
namespace RTT
{
    ostream& operator<<(ostream& os, const TypekitTest::Inertia& inertia);
    istream& operator>>(istream& is, TypekitTest::Inertia& inertia);
} // namespace RTT

namespace TypekitTest
{

using namespace RTT;
using namespace RTT::detail;
using namespace std;

TypekitTest::Inertia createInertia(double ix, double iy, double iz, double ixy, double ixz, double iyz);

struct InertiaTypeInfo :
        public TemplateTypeInfo<TypekitTest::Inertia,true>
{
    InertiaTypeInfo() :
        TemplateTypeInfo<TypekitTest::Inertia,true>("Inertia") {};

    bool decomposeTypeImpl(const TypekitTest::Inertia inertia, PropertyBag& targetbag) const;
    bool composeTypeImpl(const PropertyBag& bag, TypekitTest::Inertia inertia) const;
};

}

#endif // INERTIA_TYPEINFO_H
